\usepackage{nicefrac}
\usepackage{verbatim}
\usepackage{multirow}

% macros
\setcounter{secnumdepth}{5} % to get numbered paragraphs
\newcommand{\ifnotempty}[2]{\ifx\relax#1\relax\else#2\fi}
\newcommand{\ifnotemptyelse}[3]{\ifx\relax#1\relax#3\else#2\fi}
\newcommand{\all}[2]{\forall #1. #2}
\newcommand{\some}[2]{\exists #1. #2}
\newcommand{\setst}[2]{\{#1\mathrel{|}#2\}}
\newcommand{\pair}[2]{(#1,#2)}
\newcommand{\set}[1]{\{ #1 \}}
\newcommand{\tuple}[1]{\langle #1 \rangle}
\newcommand{\powset}[1]{2^{#1}}
\newcommand{\with}[1]{[#1]}
\newcommand{\subst}[2]{{#1}\mapsto{#2}}
\newcommand{\dontcare}{\cdot}
\newcommand{\map}[2]{{#1}\mapsto{#2}}

\newcommand{\lookup}[2]{#1(#2)}

\renewcommand{\epsilon}{\varepsilon}

\newcommand{\under}[2]{\underbrace{#2}_{#1}}

% metavars
\newcommand{\asubmat}{X}
\newcommand{\bsubmat}{Y}
\newcommand{\csubmat}{Z}
\newcommand{\xs}{\bar{\asubmat}}
\newcommand{\ys}{\bar{\bsubmat}}
\newcommand{\zs}{\bar{\csubmat}}
\newcommand{\mat}[1]{\mathbf{#1}}
\newcommand{\amat}{\mat{A}}
\newcommand{\bmat}{\mat{B}}
\newcommand{\cmat}{\mat{C}}
\newcommand{\self}{\mathbf{self}}
\newcommand{\selfid}{\mathbf{selfid}}
%\newcommand{\delay}[2][]{\delta_{#2}\ifnotempty{#1}{^{#1}}}
\newcommand{\aconst}[1][]{c\ifnotempty{#1}{_{#1}}}
\newcommand{\timing}[1][]{\tau\ifnotempty{#1}{_{#1}}}
\newcommand{\timeseq}[1][]{\bar\tau\ifnotempty{#1}{_{#1}}}
\newcommand{\boolform}{\phi}  % boolean formula
\newcommand{\apair}{p}
\newcommand{\pairs}{\bar\apair}
\newcommand{\atuple}{t}

%paths
\newcommand{\tcomb}[1][]{\oplus\ifnotempty{#1}{_{#1}}} % combine timers

% pseudocode
\renewcommand{\split}[3]{\textbf{split}\ifnotempty{#1}{(#1,#2,#3)}}
\newcommand{\send}[2]{\textbf{send}\ifnotempty{#1}{(#1,#2)}}
\newcommand{\recv}[1]{\textbf{recv}\ifnotempty{#1}{(#1)}}
\newcommand{\tgt}[2]{\textbf{tgt}\ifnotempty{#1}{(#1,#2)}}
\newcommand{\locmm}[2]{\textbf{locMM}\ifnotempty{#1}{(#1,#2)}}
\newcommand{\wb}[2]{\textbf{reduce}\ifnotempty{#1}{(#1,#2)}}
\newcommand{\barrier}{\textbf{barrier}}


% clock labels
% \clock{a}{T<0?}{U=0}

\newcommand{\timer}[1]{\ensuremath{(#1)?}}
\newcommand{\clock}[3]{
  \begin{tabular}{l}
	\ifnotempty{#1}{$#1$}
	\ifnotempty{#3}{\ifnotempty{#1}{;}\ $#3$}
  	\ifnotempty{#2}{;\ $\timer{#2}$}
  \end{tabular}	
}
\newcommand{\atimer}[1][]{\ensuremath{T\ifnotempty{{#1}}{_{#1}}}}
\newcommand{\atimers}{\bar\atimer}
\newcommand{\btimer}[1][]{\ensuremath{U\ifnotempty{{#1}}{_{#1}}}}
\newcommand{\ctimer}[1][]{\ensuremath{V\ifnotempty{{#1}}{_{#1}}}}
\newcommand{\dtimer}[1][]{\ensuremath{W\ifnotempty{{#1}}{_{#1}}}}

\newcommand{\aclk}{k}
\newcommand{\clocks}{\bar\atimer}
\newcommand{\aclks}{\bar\atimer}
\newcommand{\timersep}{,}

\newcommand{\goto}[2][]{
	\aput{:U}{#2}
	\ifnotempty{#1}{\bput{:U}{{#1}}}
}
% \goto, but rotated 90 CW
\newcommand{\bgoto}[2][]{
	\aput{:270}{#2}
	\ifnotempty{#1}{\bput{:270}{#1}}
}
\newcommand{\cgoto}[2][]{
	\aput{:90}{#2}
	\ifnotempty{#1}{\bput{:90}{#1}}
}
\newcommand{\dgoto}[2][]{
	\aput{:D}{#1}
	\ifnotempty{#2}{\bput{:D}{#2}}
}




% automata
\newcommand{\atfa}[1][]{\mathbf{A}\ifnotempty{#1}{_{#1}}}
\newcommand{\btfa}{\mathbf{B}}
% \tfa{\Aalpha}{\astates}{\state[0]}{\accept}{\aclks}{\tbareln}{\ireln}{\creln}
\newcommand{\tfa}[8]{\tuple{{#1},{#2},{#3},{#4},{#5},{#6},{#7},{#8}}}
\newcommand{\atfas}{\bar\atfa}
\newcommand{\astates}{Q}
\newcommand{\Aalpha}{\Sigma}
\newcommand{\aalpha}[1][]{\sigma\ifnotempty{#1}{_{#1}}}
\newcommand{\astring}{\bar\aalpha}
\newcommand{\state}[1][]{q\ifnotempty{#1}{_{#1}}}
\newcommand{\states}{\bar\state}
\newcommand{\vstates}{\vec\state}
\newcommand{\bstate}[1][]{s\ifnotempty{#1}{_{#1}}}
\newcommand{\cstate}[1][]{t\ifnotempty{#1}{_{#1}}}
\newcommand{\start}{s}
\newcommand{\accept}{\state[f]}
\newcommand{\accepts}{F}
\newcommand{\reln}{\delta}

\renewcommand{\path}[1]{(#1)}
\newcommand{\paths}[1]{\mathbf{paths}(#1)}
\newcommand{\trans}[4][]{#2\xrightarrow[#1]{#3}#4}

\newcommand{\undef}{\cdot}
\newcommand{\apath}[1][]{p\ifnotempty{#1}{_{#1}}}


% TBA
\newcommand{\atba}[1][]{\mathcal{A}\ifnotempty{#1}{_{#1}}}
\newcommand{\tbareln}{\delta}
\newcommand{\infwd}[1]{#1^\omega}
\newcommand{\arun}{r}
\newcommand{\aprefix}{p}
\newcommand{\clkint}[1][]{\nu\ifnotempty{#1}{_{#1}}}
\newcommand{\clkints}{\bar\clkint}
\newcommand{\vclkints}{\vec\clkint}
\newcommand{\runto}[2]{ \xrightarrow[#1]{#2}}
\newcommand{\CPs}[2]{\Pi({#1,#2})}
\renewcommand{\inf}[1]{\ensuremath{inf({#1})}}
\newcommand{\aword}{w}

\newcommand{\ireln}[1][]{\gamma\ifnotempty{#1}{_{#1}}}  % timer initialization relation
\newcommand{\creln}[1][]{\eta\ifnotempty{#1}_{#1}}    % timer constraint     relation

\newcommand{\epair}[1][]{e\ifnotempty{{#1}}{_{#1}}}
\newcommand{\epairs}{\bar\epair}
\newcommand{\aedge}[1][]{e\ifnotempty{{#1}}{_{#1}}}
\newcommand{\langof}[1]{L({#1})}

\newcommand{\pathdelay}[3]{\Delta({#1}\ifnotempty{#2}{, {#2} \to{#3}})}
\newcommand{\timerspan}[3]{\mathbf{span}({#1},{#2},{#3})}
%$\timerbound{\atimer}{\apath}$
\newcommand{\timerbound}[2]{\mathbf{bound}({#1},{#2})}
\newcommand{\goesto}{\to^*}


% <Sigma, Q, q0, F, C, \delta, \ireln, \creln>
% \tba{\Aalpha}{\astates}{\state[0]}{\accept}{\aclks}{\tbareln}{\ireln}{\creln}
\newcommand{\tba}[8]{\tuple{{#1},{#2},{#3},{#4},{#5},{#6},{#7},{#8}}}

% Parallel Timing Systems
\newcommand{\pts}[4]{\tuple{{#1},{#2},{#3},{#4}}}
\newcommand{\tbaparent}[1][]{P\ifnotempty{#1}{_{#1}}}
\newcommand{\tbachild}[1][]{\ensuremath{\atfa\ifnotempty{#1}_{{#1}}}}
\newcommand{\tbachildren}{\bar\tbachild}
\newcommand{\apts}[1][]{S\ifnotempty{#1}{_{#1}}}
\newcommand{\forkreln}{\psi}
\newcommand{\joinreln}{\varphi}
\newcommand{\symfork}{\Psi}
\newcommand{\symjoin}{\Omega}
\newcommand{\fork}[1]{\ensuremath{\symfork}({#1})}
\newcommand{\join}[1]{\ensuremath{\symjoin}({#1})}
\newcommand{\forkconst}[3]{\langle #1 \xrightarrow{#2} #3 \rangle}
\newcommand{\joinconst}[3]{\langle #1 \xrightarrow[{\timer{{#2}}}]{} #3 \rangle}
\newcommand{\flatten}[1]{\mathbf{flatten}{(#1)}}
\newcommand{\uses}[2][]{\mathbf{pairs}{(\ifnotempty{#1}{#1,}{#2})}}
\newcommand{\timerof}[1]{\mathbf{timer}{(#1)}}
%\newcommand{\tlookup}[2]{\mathbf{lookup}{(#1,#2)}}


% Theorem-like environments
\usepackage{amsthm}
\newtheorem{theorem}{Theorem}
\newtheorem{definition}[theorem]{Definition}
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{notation}[theorem]{Notation}
\newtheorem{example}[theorem]{Example}
\newtheorem{corollary}[theorem]{Corollary}
\numberwithin{equation}{theorem} % To number equations using theorem numbering scheme
\newtheorem*{note}{Note}


% functions
%\newcommand{\dmax}[1][]{\Delta\ifnotempty{#1}{({#1})}}
\newcommand{\delayTFA}[1][]{\Delta\ifnotempty{#1}{_{#1}}}
\newcommand{\delayTBA}[2][]{\Delta\ifnotempty{#1}{_{#1}}({#2})}
\newcommand{\uconstraint}[1][]{\chi\ifnotempty{#1}{({#1})}}
\newcommand{\constraint}{\rho}
\newcommand{\Constraint}{X}
\newcommand{\constraints}[1][]{\Constraint\ifnotempty{#1}{(#1)}}
\newcommand{\const}[2]{\mathbf{constraints}(#1,#2)}
\newcommand{\constLT}[2]{\mathbf{constraints}_<(#1,#2)}
\newcommand{\constGT}[2]{\mathbf{constraints}_>(#1,#2)}
\newcommand{\constEQ}[2]{\mathbf{constraints}_=(#1,#2)}
\newcommand{\LT}[2]{\timer{#1 < #2}}

% misc
\newcommand{\buchi}{B\"{u}chi\ }
\newcommand{\naturals}[1][]{\mathbb{N}\ifnotempty{#1}{^{#1}}}
\newcommand{\reals}[1][]{\mathbb{R}\ifnotempty{#1}{^{#1}}}
\newcommand{\NP}{{\bfseries NP}}
\newcommand{\PSPACE}{{\bfseries PSPACE}}

% DFA states
\newcommand{\stij}[3]{\ensuremath{#1^{i=#2}_{j=#3}}}  % state with bound vals for i,j

% Statements
\newcommand{\stfork}[1]{\mathbf{fork}({#1})}
\newcommand{\stjoin}[1]{\mathbf{join}({#1})}


